#!/usr/bin/perl
# サーバのパスに合わせる
#use KCatch qw( mode=html );
use strict;
use utf8;

######################################################################
# 縦書き化CGI「竹取2.0」taketori.cgi 2.0.2
# Copyright (C) 2011 CMONOS (ENDO chihiro)
#
# ライセンス：非商用のみ無料(商用利用についてはお問い合わせください)
#
# support@cmonos.jp
# http://cmonos.jp/
# 最終更新日：2012-06-19
######################################################################
my(@target_url,$nofollow,$fontsize,$font_family,$zh_font_family,@target_id,@target_class,@skip_class,$margin,$height,$colmargin,$whole_page,$clear_left,$style);

# 縦書き返還対象 URL
@target_url = (
#	'http://www\.aozora\.gr\.jp/',	#縦書き変換対象URLを「青空文庫」のみに限定する
);

# 1=リンクをたどらない
$nofollow = 0;

# フォントサイズ
$fontsize = 14;

# 1段の高さ
$height = 294;

# 行間隔
$margin = 7;

# 段間隔
$colmargin = 14;

# フォント
$font_family = '\'ヒラギノ明朝 Pro W3\',\'Hiragino Mincho Pro\',\'HiraMinProN-W3\',\'ＭＳ Ｐ明朝\',\'MS PMincho\',\'ＭＳ 明朝\',\'MS Mincho\',serif';
#$font_family = '\'Hiragino Kaku Gothic Pro\',\'ヒラギノ角ゴ Pro W3\',\'HiraKakuProN-W3\',\'ＭＳ ゴシック\',\'MS Gothic\',Osaka,Verdana,arial,helvetica,sans-serif'; # メイリオとMS Pゴシックを指定すると IE6 で約物を表示できなくなります。

# 中国語フォント
$zh_font_family = '\'Apple LiSong\', Times, \'Times New Roman\', \'新細明體\', PMingLiu, serif';

# ページ全体を縦書きする(1/0)
$whole_page = 0;

# 縦書き開始位置で左フロートを解除する(1/0)
$clear_left = 0;

# デフォルトのターゲットid (配列)
@target_id = ();

# デフォルトのターゲットclass (配列)
@target_class = ();

# デフォルトのターゲット除外class (配列)
@skip_class = ();

# 追加 style
$style =<<STYLE;

STYLE
######################################################################
use lib './lib';
require CMONOS::CGI_Lib::HTTP_Client;
require CMONOS::CGI_Lib::Taketori;
use Jcode;
binmode STDOUT, ":utf8";
$HTTP_Client::UserAgent = 'Taketori/2.0';
$HTTP_Client::UserAgent = $ENV{'HTTP_USER_AGENT'} if $ENV{'HTTP_USER_AGENT'};
my $done = 0;
my $msg = '';
my $url = ($ENV{'PATH_INFO'}) ? $ENV{'PATH_INFO'} : ($ENV{'QUERY_STRING'} && $ENV{'QUERY_STRING'} =~ /url=([^&]+)/) ? $1 : '';
my $target_section = '';
if ($url) {
	$url = &url_encode(&url_decode($url));
	$url =~ s/%3F/\?/i;
	$url =~ s/%40/\@/i;
	$url =~ s/%23/\#/i;
	$url =~ s!^/!!;
	$url = 'http://' . $url if $url !~ m!^https?://!i;
}
$url =~ s/#[^\/]*?$//;
1 while $url =~ s!//?((?:\.[0-9a-zA-Z_\-]+|(?:[0-9a-zA-Z_]+=[^\/&]+&?)+)(?:\@[^/]+)?)$!\@$1!; #互換性
while ($url =~ s!\@((\-?)\.?)([^/\@]*)$!!) {
	my($class,$skip_mark,$value) = ($1,$2,$3);
	if (!$value) {
		$whole_page = 1;
	} elsif ($value =~ /=/) {
		while ($value =~ /\G([0-9a-zA-Z_]+)=([^\/&]+)&?/g) {
			my($k,$v) = (lc($1),$2);
			if ($k eq 'fontsize') {
				$fontsize = $v;
			} elsif ($k eq 'height') {
				$height = $v;
			} elsif ($k eq 'margin') {
				$margin = $v;
			} elsif ($k eq 'colmargin') {
				$colmargin = $v;
			} elsif ($k eq 'wholepage') {
				$whole_page = $v;
			} elsif ($k eq 'clearleft') {
				$clear_left = $v;
			} elsif ($k eq 'fontfamily') {
				$font_family = ($v eq 'sans-serif') ? '\'Hiragino Kaku Gothic Pro\',\'ヒラギノ角ゴ Pro W3\',\'HiraKakuProN-W3\',\'ＭＳ ゴシック\',\'MS Gothic\',Osaka,Verdana,arial,helvetica,sans-serif' : '\'ヒラギノ明朝 Pro W3\',\'Hiragino Mincho Pro\',\'HiraMinProN-W3\',\'ＭＳ Ｐ明朝\',\'MS PMincho\',\'ＭＳ 明朝\',\'MS Mincho\',serif';
				$zh_font_family = ($v eq 'sans-serif') ? '\'Heiti TC\', \'LiHei Pro\', \'微軟正黑體\', Arial, Helvetica, sans-serif' : '\'Apple LiSong\', Times, \'Times New Roman\', \'新細明體\', PMingLiu, serif';
			}
		}
	} elsif ($class) {
		push(@target_class,$value);
		push(@skip_class,$value) if $skip_mark;
	} else {
		push(@target_id,$value);
	}
	$target_section = '@' . $class . $value . $target_section;
}
my $script_url = (($ENV{'HTTPS'} || ($ENV{'SERVER_PORT'} && $ENV{'SERVER_PORT'} == 443)) ? 'https://' : 'http://')
	.	(($ENV{'SERVER_NAME'}) ? $ENV{'SERVER_NAME'} : gethostbyaddr(pack("C4", split(/\./, $ENV{'SERVER_ADDR'})), $ENV{'SERVER_ADDR'}))
	.	(($ENV{'SERVER_PORT'} != 80 && $ENV{'SERVER_PORT'} != 443) ? ':' . $ENV{'SERVER_PORT'} : '') . $ENV{'SCRIPT_NAME'};
if (&is_target_url($url,$script_url,\@target_url)) {
	my $res = HTTP_Client->new->request('GET' => $url);
	my $content;
	$content = $res->content('utf8') if $res->is_success;
	$msg = $res->message;
	undef $res;
	if ($content && $content =~ /<body(?![0-9a-zA-Z_])[^>]*>/is) {
		my $lang =	($content =~ /<html[^>]+lang=["']?ja[^>]*>/i) ? 'ja' : 
					($content =~ /<html[^>]+lang=["']?zh[^>]*>/i) ? 'zh' :
					($content =~ /<[0-9a-zA-Z_]+[^>]+lang=["']?ja[^>]*>/i) ? 'ja' :
					($content =~ /<[0-9a-zA-Z_]+[^>]+lang=["']?zh[^>]*>/i) ? 'ja' :
					'ja';
		$style = Taketori->new({'lang' => $lang})->css . "\nspan.tktr-gyo {\n  font-family: " . (($lang eq 'ja') ? $font_family : $zh_font_family) . " !important;\n}\n" . $style;
		my $whole_tategaki_option = {
			'fontsize'	=> $fontsize,
			'margin'	=> $margin,
			'colmargin'	=> $colmargin,
			'height'	=> $height,
			'css'		=> 1,
			'lang'		=> $lang,
		};
		$content =~ s/<meta(?![0-9a-zA-Z_])[^>]*\shttp-equiv=["']?Content-Type["']?[^>]*>//sgi;
		$content =~ s/<meta(?![0-9a-zA-Z_])[^>]*\sname="robots"[^>]*>//sgi;
		$content =~ s/(<head(?![0-9a-zA-Z_])[^>]*>)/$1\n<link rel="canonical" href="$url" \/>/sgi if $content !~ /<link(?![0-9a-zA-Z_])[^>]*\srel=["']?canonical["']?[^>]+>/si;
		$content =~ s/(<head(?![0-9a-zA-Z_])[^>]*>)/$1\n<base href="$url" \/>/sgi if $content !~ /<base(?![0-9a-zA-Z_])[^>]*\shref=[^>]+>/si;
		$content =~ s/(<head(?![0-9a-zA-Z_])[^>]*>)/$1\n<meta http-equiv="Content-Type" content="text\/html;charset=UTF-8" \/>\n<meta name="robots" content="noindex,nofollow,noarchive" \/>/sgi;
		$content =~ s/(<head(?![0-9a-zA-Z_])[^>]*>)/$1\n<meta name="viewport" content="width=device-width" \/>/sgi if $whole_page;
		$content =~ s/(<\/head(?![0-9a-zA-Z_])[^>]*>)/<style type="text\/css">$style<\/style>$1/sgi;
		if ($whole_page) {
			$content =~ s/<(\/?)(?:table|tbody|thead|tfoot|caption|tr|th|td)(?![a-zA-Z])[^>]*?>/<${1}div>/sgi;
		}
		$content =~ s!(<div class="[^"]+">)([\x09\x0A\x0C\x0D\x20]*<p>.*?</p>[\x09\x0A\x0C\x0D\x20]*)</div>(?=[\x09\x0A\x0C\x0D\x20]*\1)!$2!sig;
		$content =~ s/<div[^>]*>((?:(?!<\/?(?:div|table|t[dh]|span class="tktr-gyo")(?![0-9a-zA-Z_])[^>]*>).)*?)<\/div>(?=[\x09\x0A\x0C\x0D\x20]*(?:<br[^"]*>)+)/<p>$1<\/p>/sig;
		$content =~ s/<div(?:\s+style="[^"]+"\s*|)>((?:(?!<\/?(?:div|table|t[dh]|span class="tktr-gyo")(?![0-9a-zA-Z_])[^>]*>).)*?)<\/div>/<p>$1<\/p>/sig;
		if ($whole_page) {
			$content = Taketori->new->tategaki($content,$whole_tategaki_option);
		} else {
			my $tategaki_option = {
				'fontsize'	=> $fontsize,
				'margin'	=> $margin,
				'colmargin'	=> $colmargin,
				'height'	=> $height,
				'class'		=> 'tategaki',
				'style'		=> 'margin-top:10px;width:100%;',
				'css'		=> 1,
				'lang'		=> $lang,
				'clear' => 1
			};
			if (@target_id) {
				foreach my $id (@target_id) {
					$content =~ s/(<([0-9a-zA-Z_]+)(?![0-9a-zA-Z_])[^>]*id=["']?$id["']?[^>]*>)((?:(?!<\2(?![0-9a-zA-Z_])[^>]*>).)*?)(<\/\2>)/&tategaki_section($2,$1,$3,$4,\$done,$tategaki_option,$clear_left)/iesg;
					$content =~ s/(<([0-9a-zA-Z_]+)(?![0-9a-zA-Z_])[^>]*id=["']?$id["']?[^>]*>)((?:(?!<\/\2(?![0-9a-zA-Z_])[^>]*>).)*?)(<\2(?![0-9a-zA-Z_])[^>]*>)/&tategaki_section($2,$1,$3,'',\$done,$tategaki_option,$clear_left) . $4/iesg;
				}
			}
			if (@target_class) {
				foreach my $class (@target_class) {
					$content =~ s/(<([0-9a-zA-Z_]+)(?![0-9a-zA-Z_])[^>]*class=["']?[^"'>]*$class(?![0-9a-zA-Z_])[^"'>]*[^>]*>)((?:(?!<\2(?![0-9a-zA-Z_])[^>]*>).)*?)(<\/\2>)/&tategaki_section($2,$1,$3,$4,\$done,$tategaki_option,\@skip_class,$clear_left)/iesg;
					$content =~ s/(<([0-9a-zA-Z_]+)(?![0-9a-zA-Z_])[^>]*class=["']?[^"'>]*$class(?![0-9a-zA-Z_])[^"'>]*[^>]*>)((?:(?!<\/\2(?![0-9a-zA-Z_])[^>]*>).)*?)(<\2(?![0-9a-zA-Z_])[^>]*>)/&tategaki_section($2,$1,$3,'',\$done,$tategaki_option,\@skip_class,$clear_left) . $4/iesg;
				}
			}
			if (!$done) {
				$content =~ s/(<p(?![0-9a-zA-Z_])[^>]*>(?:(?!<\/?(?:div|table|t[dh]|span class="tktr-gyo")(?![0-9a-zA-Z_])[^>]*>).)*<\/p>)/&tategaki($1,\$done,$tategaki_option,$clear_left)/iesg;
				#$content =~ s/(<div(?![0-9a-zA-Z_])[^>]*>)((?:(?!<(?:div(?![0-9a-zA-Z_])|span class="tktr-gyo")[^>]*>).)*?)(<\/div>)/$1 . &tategaki($2,\$done,$tategaki_option,$clear_left) . $3/iesg;
				$content =~ s/(<(?:\/?div|\/table)(?![0-9a-zA-Z_])[^>]*>)((?:(?!<(?:\/?div(?![0-9a-zA-Z_])|table(?![0-9a-zA-Z_])|\/?t[dh](?![0-9a-zA-Z_])|span class="tktr-gyo")[^>]*>).)*?.(?=<(?:\/?div|table)(?![0-9a-zA-Z_])[^>]*>))/$1 . &tategaki($2,\$done,$tategaki_option,$clear_left)/iesg;
				if (!$done) {
					$content = Taketori->new->tategaki($content,$whole_tategaki_option) if !$done;
				}
			}
		}
		$content =~ s/(<frame(?![0-9a-zA-Z_])[^>]*[\x09\x0A\x0C\x0D\x20]+src=['"]?)([^"'>\x09\x0A\x0C\x0D\x20]+)([^>]*>)/$1 . &tategaki_url($2,$url,$script_url,\@target_url,$target_section) . $3/iesg;
		$content =~ s/(<a(?![0-9a-zA-Z_])[^>]*[\x09\x0A\x0C\x0D\x20]+href=['"]?)([^"'>\x09\x0A\x0C\x0D\x20]+)([^>]*>)/$1 . &tategaki_url($2,$url,$script_url,\@target_url,$target_section) . $3/iesg if !$nofollow;
		print "Content-Type: text/html\n\n";
		print $content;
		#print $msg;
	} else {
		print "Location: $url\n\n";
	}
	exit;
} else {
	$msg = 'invalid url';
}
$script_url =~ s/[^\/]+$/index.html/;
#print "Content-Type: text/plain\n\n $msg:$url";
print "Location: $script_url\n\n";

# %をエンコードしない URL エンコード
sub url_encode ($) {
my $url = shift;
return '' if !defined $url || $url eq '';
utf8::encode($url) if utf8::is_utf8($url);
$url =~ s/([\x00-\x1F\x21-\x24\x27-\x29\x2B\x2C\x3B-\x3C\x3E\x3F\x5B-\x5E\x60\x7B-\xFF])/'%' . sprintf("%.2X", unpack("C", $1))/eg;
$url =~ s/\x20/\+/g;
return $url;
}

sub url_decode ($) {
my $v = shift;
$v =~ s/%([A-Fa-f0-9][A-Fa-f0-9])/pack("C",hex($1))/ge;
$v =~ s/\+/\x20/g;
return $v;
}

sub is_target_url ($$) {
my($url,$script_url,$target_url) = @_;
return (
		$url
	 &&	$url =~ /^https?:\/\/[0-9a-zA-Z_\-\.]+\.[0-9a-zA-Z_]+\//i
	 &&	$url !~ /$script_url/i
	 &&	$url !~ /\.(?:jpg|jpeg|gif|png|pdf|doc|exe|xls|csv|txt|mov|wmv|mpg|mp4)/is
	 && (!@$target_url || grep($url =~ /^$_/,@target_url))
) ? 1 : 0;
}

sub tategaki_section ($$$$$;$$$) {
my($tag,$open_tag,$content,$close_tag,$done_ref,$option,$skip_class,$clear_left) = @_;
my %option;
if ($clear_left) {
	my $text = $content;
	$text =~ s/(?:<form(?![0-9a-zA-Z_])[^>]*>.*?<\/form>|<iframe(?![0-9a-zA-Z_])[^>]*>.*?<\/iframe>|<script(?![0-9a-zA-Z_])[^>]*>.*?<\/script>|<table(?![0-9a-zA-Z_])[^>]*>.*?<\/table>|<!--.*?-->|<.*?>)//igs;
	if ($text > 200) {
		%option = %$option;
		$option{'style'} .= 'clear:left;';
		$option = \%option;
	}
}
$$done_ref = 1;
if (ref $skip_class && grep($open_tag =~ / class=["']?(?:[^"'>]+[\x09\x0A\x0C\x0D\x20])?$_(?![0-9a-zA-Z_])/is,@$skip_class)) {
	return $open_tag . $content . $close_tag;
}
if ($tag =~ /^(?:div|dt|dd|td|th|li|address)$/i || !$close_tag) {
	return $open_tag . Taketori->new($option)->tategaki($content) . $close_tag;
} else {
	return Taketori->new($option)->tategaki($open_tag . $content . $close_tag);
}
}

sub tategaki ($$;$$) {
my($content,$done_ref,$option,$clear_left) = @_;
my $count = 0;
my $text = $content;
$text =~ s/(?:<form(?![0-9a-zA-Z_])[^>]*>.*?<\/form>|<iframe(?![0-9a-zA-Z_])[^>]*>.*?<\/iframe>|<script(?![0-9a-zA-Z_])[^>]*>.*?<\/script>|<table(?![0-9a-zA-Z_])[^>]*>.*?<\/table>|<!--.*?-->|<.*?>)//igs;
my %option;
if ($clear_left && length $text > 200) {
	%option = %$option;
	$option{'style'} .= 'clear:left;';
	$option = \%option;
}
while ($text =~ /[。．]/g) {
	if (++$count == 3) {
		$$done_ref = 1;
		return Taketori->new($option)->tategaki($content);
	}
}
return $content if !$count;
while ($text =~ /[、|，|？|！]/g) {
	if (++$count == 5) {
		$$done_ref = 1;
		return Taketori->new($option)->tategaki($content);
	}
}
return $content;
}

sub tategaki_url ($$;$$$) {
my($url,$base_url,$script_url,$target_url,$target_section) = @_;
$url = &unescape($url);
if ($url =~ /^#/) {
	return &escape($script_url . '/' . $base_url . $target_section . $url);
}
$url = 'http:' . $url if $url =~ m!^//!;
if ($url !~ m!^https?://!i && $url !~ m!^[0-9a-zA-Z_]+:!) {
	if ($url =~ m!^/!) {
		$url = ($base_url =~ m!^(https?://[^/]+)!i) ? $1 . $url : $url;
	} elsif ($url =~ m!^\.\./!) {
		$base_url =~ s!/[^/]*$!!;
		while ($url =~ s!^\.\./!!) {
			$base_url =~ s!/[^/]*$!!;
		}
		$url = $base_url . (($url ne '') ? '/' . $url : '');
	} else {
		$url =~ s!^\./!!;
		$base_url =~ s![^/]*$!$url!;
		$url = $base_url;
	}
}
$url = &url_encode($url) if $url !~ m!^javascript:!i;
if (&is_target_url($url,$script_url,$target_url)) {
	my $anchor = ($url =~ s!%23([^/]*)$!!) ? '#' . $1 : '';
	$url =~ s/%/%25/g;
	$url =~ s!^http://!!i;
	return &escape($script_url . '/' . $url . $target_section . $anchor);
} else {
	$url =~ s/%23/#/;
	$url =~ s/%3F/\?/i;
	return &escape($url);
}
}

sub escape ($) {
my $v = shift;
return '' if !defined $v;
$v =~ s/\&/&amp;/sg;
$v =~ s/</&lt;/sg;
$v =~ s/>/&gt;/sg;
$v =~ s/"/&quot;/sg;
$v =~ s/\x0A/&#10;/g;
return $v;
}

sub unescape ($) {
my $v = shift;
return '' if !defined $v;
$v =~ s/&lt;/</sg;
$v =~ s/&gt;/>/sg;
$v =~ s/&quot;/"/sg;
$v =~ s/&#10;/\x0A/sg;
$v =~ s/&amp;/\&/sg;
return $v;
}

